FieldHeapChangeSettingsEvent = {};
FieldHeapChangeSettingsEvent_mt = Class(FieldHeapChangeSettingsEvent, Event);
InitEventClass(FieldHeapChangeSettingsEvent, "FieldHeapChangeSettingsEvent");

FieldHeapChangeSettingsEvent.NUM_BITS_SETTINGS_ID = 1;
FieldHeapChangeSettingsEvent.NUM_BITS_STATE = 2;

---Create instance of Event class
-- @return table self instance of class event
function FieldHeapChangeSettingsEvent.emptyNew()
    local self = Event.new(FieldHeapChangeSettingsEvent_mt);
    return self;
end;

---Create new instance of event
-- @param table object object
-- @param string, string
function FieldHeapChangeSettingsEvent.new(settingsId, settingsState)
    local self = FieldHeapChangeSettingsEvent.emptyNew();
    self.settingsId = settingsId;
    self.settingsState = tostring(settingsState);	
    return self;
end;

---Called on client side on join
-- @param string streamId streamId
-- @param string connection connection
function FieldHeapChangeSettingsEvent:readStream(streamId, connection)
    self.settingsId = streamReadString(streamId, FieldHeapChangeSettingsEvent.NUM_BITS_SETTINGS_ID);
    self.settingsState = streamReadString(streamId, FieldHeapChangeSettingsEvent.NUM_BITS_STATE);
    self:run(connection);
end;

---Called on server side on join
-- @param string streamId streamId
-- @param string connection connection
function FieldHeapChangeSettingsEvent:writeStream(streamId, connection)
    streamWriteString(streamId, self.settingsId, FieldHeapChangeSettingsEvent.NUM_BITS_SETTINGS_ID);
    streamWriteString(streamId, self.settingsState, FieldHeapChangeSettingsEvent.NUM_BITS_STATE);
end;

---Run action on receiving side
-- @param string connection connection
function FieldHeapChangeSettingsEvent:run(connection)		
	if self.settingsId == "fieldHeapMission_minMax" then
		g_additionalContractTypes:getTyp("fieldHeapMission"):setMaxNumInstance(g_additionalContractUtils:getTypToString(self.settingsState));
	end;	
    if g_server ~= nil then
        g_server:broadcastEvent(self, false);
    end;
end;

